--Declaring
ProfessionBars = LibStub("AceAddon-3.0"):NewAddon("ProfessionBars", "AceEvent-3.0", "AceTimer-3.0")
profbars_options = {
	name = "ProfessionBars",
	handler = ProfessionBars,
	type = 'group',
	args = {
		mode = {
			type = 'input',
			name = 'Mode',
			desc = 'Set the Mode PB runs in. Mode 1 means that the bars are seperate and draggable. Mode 2 means that the bars are attached to the Tradeskill Window.',
			set = 'SetMode',
			get = 'GetMode',
		},
	},
}

local function PlayerHasSpell(spellID)
	local a = GetSpellInfo(spellID);
	local b = GetSpellInfo(a);
	if b then
		return true
	else
		return false
	end
end

function ProfessionBars:SetMode(info, input)
	local a = tonumber(input);
	if not (a==1 or a==2) then
		print("ProfessionBars is currently running in Mode "..profbars_data.mode);
	else
		local b
		if profbars_data.mode == a then
			b = true;
		else
			b = false;
		end
		profbars_data.mode = a;
		print("ProfessionBars is now running in mode "..a);
		if profbars_data.mode == 1 then
			ProfessionBars:PLAYER_ENTERING_WORLD()
		else
			if PlayerHasSpell(25229) then
				profbars_jcmove:Hide();
				profbars_jewelcrafting:Hide();
				profbars_jewelcrafting:SetWidth(profbars_jewelcrafting:GetWidth()-17.5);
			end
			if PlayerHasSpell(45357) then
				profbars_inscmove:Hide();
				profbars_inscription:Hide();
				profbars_inscription:SetWidth(profbars_inscription:GetWidth()-17.5);
			end
		end
	end
end

function ProfessionBars:GetMode()
	return profbars_data.mode
end

function ProfessionBars:insc_showhide(level)
	profbars_inscbutton9:Hide();
	profbars_inscbutton8:Hide();
	profbars_inscbutton7:Hide();
	profbars_inscbutton6:Hide();
	profbars_inscbutton5:Hide();
	profbars_inscbutton4:Hide();
	profbars_inscbutton2:Hide();
	profbars_inscbutton1:Hide();
	profbars_inscmove:Hide();
	profbars_inscription:Hide();
	local a
	if level >= 1 then
		profbars_inscbutton9:Show();
		if not (profbars_data.mode == 2) then
			profbars_inscmove:Show();
		end
		profbars_inscription:Show();
		a=1;
	end
	if level >= 25 then
		profbars_inscbutton8:Show();
		a=2;
	end
	if level >=75 then
		profbars_inscbutton7:Show();
		a=3;
	end
	if level >=125 then
		profbars_inscbutton6:Show();
		a=4;
	end
	if level >=175 then
		profbars_inscbutton5:Show();
		a=5;
	end
	if level >=225 then
		profbars_inscbutton4:Show();
		a=6;
	end
	if level >=275 then
		profbars_inscbutton1:Show();
		a=7;
	end
	if level >=325 then
		profbars_inscbutton2:Show();
		a=8;
	end
	local width
	if profbars_data.mode == 2 then
		width = 35*a;
	else
		width = 35*a+17.5;
	end
	profbars_inscription:SetWidth(width);
	profbars_inscmove:ClearAllPoints();
	profbars_inscmove:SetPoint("TOPRIGHT", profbars_inscription, "TOPRIGHT");
end

function ProfessionBars:jc_showhide(level)
	profbars_jcbutton9:Hide();
	profbars_jcbutton8:Hide();
	profbars_jcbutton7:Hide();
	profbars_jcbutton6:Hide();
	profbars_jcbutton5:Hide();
	profbars_jcbutton4:Hide();
	profbars_jcbutton3:Hide();
	profbars_jcbutton2:Hide();
	profbars_jcbutton1:Hide();
	profbars_jcmove:Hide();
	profbars_jewelcrafting:Hide();
	local a
	if level >= 20 then
		profbars_jcbutton9:Show();
		if not (profbars_data.mode == 2) then
			profbars_jcmove:Show();
		end
		profbars_jewelcrafting:Show();
		a=1;
	end
	if level >= 50 then
		profbars_jcbutton8:Show();
		a=2;
	end
	if level >=125 then
		profbars_jcbutton7:Show();
		a=3;
	end
	if level >=175 then
		profbars_jcbutton6:Show();
		a=4;
	end
	if level >=250 then
		profbars_jcbutton5:Show();
		a=5;
	end
	if level >=275 then
		profbars_jcbutton4:Show();
		a=6;
	end
	if level >=325 then
		profbars_jcbutton1:Show();
		a=7;
	end
	if level >=350 then
		profbars_jcbutton2:Show();
		a=8;
	end
	if level >=400 then
		profbars_jcbutton3:Show();
		a=9;
	end
	local width
	if profbars_data.mode == 2 then
		width = 35*a;
	else
		width = 35*a+17.5;
	end
	profbars_jewelcrafting:SetWidth(width);
	profbars_jcmove:ClearAllPoints();
	profbars_jcmove:SetPoint("TOPRIGHT", profbars_jewelcrafting, "TOPRIGHT");
end
local function SearchPlayerBags(itemID, occurance)
	--print("-------------");
	local found = 0;
	for i=0, 4 do
		local a = GetContainerNumSlots(i)
		for c=1, a do
			local link = GetContainerItemLink(i, c);
			local name = GetItemInfo(itemID);
			if link then
				if string.match(link, name) then
					found = found+1;
					--print("Occurance "..found..": Bag "..i..", Slot "..c..": Item is "..link..".");
					if found == occurance then
						--print("-------------");
						return i, c
					end
				end
			end
		end
	end
	--print("-------------");
	return nil
end

function ProfessionBars:OnInitialize()
	if not profbars_data then
		profbars_data = {};
	end
	if not profbars_data.mode then
		profbars_data.mode = 1;
	end
	LibStub("AceConfig-3.0"):RegisterOptionsTable("ProfessionBars", profbars_options, {"profbars", "professionbars"});
end

function ProfessionBars:OnEnable()
	self:RegisterEvent("PLAYER_ENTERING_WORLD");
	self:RegisterEvent("CHAT_MSG_SKILL");
	self:RegisterEvent("TRADE_SKILL_SHOW");
	self:RegisterEvent("TRADE_SKILL_CLOSE");
end

function profbars_preclick_jc1(self, button, down)
	if GetItemCount(23425) then
		if not (GetItemCount(23425) < 5) then
			local a, b = SearchPlayerBags(23425, 1);
			local _, c = GetContainerItemInfo(a, b);
			local d, e, f
			if c < 5 then
				d, e = SearchPlayerBags(23425, 2);
				_, f = GetContainerItemInfo(d, e);
				if (c+f) < 5 then
					SplitContainerItem(d, e, f);
				else
					SplitContainerItem(d, e, (5-c));
				end
				PickupContainerItem(a, b);
				print("Re-stacked items to allow prospecting, click again to start.");
			else
				self:SetAttribute('type', 'spell');
				self:SetAttribute('spell', GetSpellInfo(31252));
				self:SetAttribute('target-item', GetItemInfo(23425));
			end
		else
			print("You don't have enough ore to prospect!");
		end
	else
		print("You don't have enough ore to prospect!");
	end
end

function profbars_preclick_jc2(self, button, down)
	if GetItemCount(36909) then
		if not (GetItemCount(36909) < 5) then
			local a, b = SearchPlayerBags(36909, 1);
			local _, c = GetContainerItemInfo(a, b);
			local d, e, f
			if c < 5 then
				d, e = SearchPlayerBags(36909, 2);
				_, f = GetContainerItemInfo(d, e);
				if (c+f) < 5 then
					SplitContainerItem(d, e, f);
				else
					SplitContainerItem(d, e, (5-c));
				end
				PickupContainerItem(a, b);
				print("Re-stacked items to allow prospecting, click again to start.");
			else
				self:SetAttribute('type', 'spell');
				self:SetAttribute('spell', GetSpellInfo(31252));
				self:SetAttribute('target-item', GetItemInfo(36909));
			end
		else
			print("You don't have enough ore to prospect!");
		end
	else
		print("You don't have enough ore to prospect!");
	end
end

function profbars_preclick_jc3(self, button, down)
	if GetItemCount(36912) then
		if not (GetItemCount(36912) < 5) then
			local a, b = SearchPlayerBags(36912, 1);
			local _, c = GetContainerItemInfo(a, b);
			local d, e, f
			if c < 5 then
				d, e = SearchPlayerBags(36912, 2);
				_, f = GetContainerItemInfo(d, e);
				if (c+f) < 5 then
					SplitContainerItem(d, e, f);
				else
					SplitContainerItem(d, e, (5-c));
				end
				PickupContainerItem(a, b);
				print("Re-stacked items to allow prospecting, click again to start.");
			else
				self:SetAttribute('type', 'spell');
				self:SetAttribute('spell', GetSpellInfo(31252));
				self:SetAttribute('target-item', GetItemInfo(36912));
			end
		else
			print("You don't have enough ore to prospect!");
		end
	else
		print("You don't have enough ore to prospect!");
	end
end

function profbars_preclick_jc4(self, button, down)
	if GetItemCount(23424) then
		if not (GetItemCount(23424) < 5) then
			local a, b = SearchPlayerBags(23424, 1);
			local _, c = GetContainerItemInfo(a, b);
			local d, e, f
			if c < 5 then
				d, e = SearchPlayerBags(23424, 2);
				_, f = GetContainerItemInfo(d, e);
				if (c+f) < 5 then
					SplitContainerItem(d, e, f);
				else
					SplitContainerItem(d, e, (5-c));
				end
				PickupContainerItem(a, b);
				print("Re-stacked items to allow prospecting, click again to start.");
			else
				self:SetAttribute('type', 'spell');
				self:SetAttribute('spell', GetSpellInfo(31252));
				self:SetAttribute('target-item', GetItemInfo(23424));
			end
		else
			print("You don't have enough ore to prospect!");
		end
	else
		print("You don't have enough ore to prospect!");
	end
end

function profbars_preclick_jc6(self, button, down)
	if GetItemCount(3858) then
		if not (GetItemCount(3858) < 5) then
			local a, b = SearchPlayerBags(3858, 1);
			local _, c = GetContainerItemInfo(a, b);
			local d, e, f
			if c < 5 then
				d, e = SearchPlayerBags(3858, 2);
				_, f = GetContainerItemInfo(d, e);
				if (c+f) < 5 then
					SplitContainerItem(d, e, f);
				else
					SplitContainerItem(d, e, (5-c));
				end
				PickupContainerItem(a, b);
				print("Re-stacked items to allow prospecting, click again to start.");
			else
				self:SetAttribute('type', 'spell');
				self:SetAttribute('spell', GetSpellInfo(31252));
				self:SetAttribute('target-item', GetItemInfo(3858));
			end
		else
			print("You don't have enough ore to prospect!");
		end
	else
		print("You don't have enough ore to prospect!");
	end
end

function profbars_preclick_jc7(self, button, down)
	if GetItemCount(2772) then
		if not (GetItemCount(2772) < 5) then
			local a, b = SearchPlayerBags(2772, 1);
			local _, c = GetContainerItemInfo(a, b);
			local d, e, f
			if c < 5 then
				d, e = SearchPlayerBags(2772, 2);
				_, f = GetContainerItemInfo(d, e);
				if (c+f) < 5 then
					SplitContainerItem(d, e, f);
				else
					SplitContainerItem(d, e, (5-c));
				end
				PickupContainerItem(a, b);
				print("Re-stacked items to allow prospecting, click again to start.");
			else
				self:SetAttribute('type', 'spell');
				self:SetAttribute('spell', GetSpellInfo(31252));
				self:SetAttribute('target-item', GetItemInfo(2772));
			end
		else
			print("You don't have enough ore to prospect!");
		end
	else
		print("You don't have enough ore to prospect!");
	end
end

function profbars_preclick_jc5(self, button, down)
	if GetItemCount(10620) then
		if not (GetItemCount(10620) < 5) then
			local a, b = SearchPlayerBags(10620, 1);
			local _, c = GetContainerItemInfo(a, b);
			local d, e, f
			if c < 5 then
				d, e = SearchPlayerBags(10620, 2);
				_, f = GetContainerItemInfo(d, e);
				if (c+f) < 5 then
					SplitContainerItem(d, e, f);
				else
					SplitContainerItem(d, e, (5-c));
				end
				PickupContainerItem(a, b);
				print("Re-stacked items to allow prospecting, click again to start.");
			else
				self:SetAttribute('type', 'spell');
				self:SetAttribute('spell', GetSpellInfo(31252));
				self:SetAttribute('target-item', GetItemInfo(10620));
			end
		else
			print("You don't have enough ore to prospect!");
		end
	else
		print("You don't have enough ore to prospect!");
	end
end

function profbars_preclick_jc8(self, button, down)
	if GetItemCount(2771) then
		if not (GetItemCount(2771) < 5) then
			local a, b = SearchPlayerBags(2771, 1);
			local _, c = GetContainerItemInfo(a, b);
			local d, e, f
			if c < 5 then
				d, e = SearchPlayerBags(2771, 2);
				_, f = GetContainerItemInfo(d, e);
				if (c+f) < 5 then
					SplitContainerItem(d, e, f);
				else
					SplitContainerItem(d, e, (5-c));
				end
				PickupContainerItem(a, b);
				print("Re-stacked items to allow prospecting, click again to start.");
			else
				self:SetAttribute('type', 'spell');
				self:SetAttribute('spell', GetSpellInfo(31252));
				self:SetAttribute('target-item', GetItemInfo(2771));
			end
		else
			print("You don't have enough ore to prospect!");
		end
	else
		print("You don't have enough ore to prospect!");
	end
end

function profbars_preclick_jc9(self, button, down)
	if GetItemCount(2770) then
		if not (GetItemCount(2770) < 5) then
			local a, b = SearchPlayerBags(2770, 1);
			local _, c = GetContainerItemInfo(a, b);
			local d, e, f
			if c < 5 then
				d, e = SearchPlayerBags(2770, 2);
				_, f = GetContainerItemInfo(d, e);
				if (c+f) < 5 then
					SplitContainerItem(d, e, f);
				else
					SplitContainerItem(d, e, (5-c));
				end
				PickupContainerItem(a, b);
				print("Re-stacked items to allow prospecting, click again to start.");
			else
				self:SetAttribute('type', 'spell');
				self:SetAttribute('spell', GetSpellInfo(31252));
				self:SetAttribute('target-item', GetItemInfo(2770));
			end
		else
			print("You don't have enough ore to prospect!");
		end
	else
		print("You don't have enough ore to prospect!");
	end
end

function profbars_preclick_insc2(self, button, down)
	if GetItemCount(36903) or GetItemCount(37921) or GetItemCount(39970) or GetItemCount(36901) or GetItemCount(36906) or GetItemCount(36905) or GetItemCount(36907) or GetItemCount(36904) then
		local item
		if GetItemCount(36903)>=5 then
			item=36903;
		elseif GetItemCount(37921)>=5 then
			item=37921;
		elseif GetItemCount(39970)>=5 then
			item=39970;
		elseif GetItemCount(36901)>=5 then
			item=36901;
		elseif GetItemCount(36906)>=5 then
			item=36906;
		elseif GetItemCount(36905)>=5 then
			item=36905;
		elseif GetItemCount(36907)>=5 then
			item=36907;
		elseif GetItemCount(36904)>=5 then
			item=36904;
		end
		if item then
			local a, b = SearchPlayerBags(item, 1);
			local _, c = GetContainerItemInfo(a, b);
			local d, e, f
			if c < 5 then
				d, e = SearchPlayerBags(item, 2);
				_, f = GetContainerItemInfo(d, e);
				if (c+f) < 5 then
					SplitContainerItem(d, e, f);
				else
					SplitContainerItem(d, e, (5-c));
				end
				PickupContainerItem(a, b);
				print("Re-stacked items to allow milling, click again to start.");
			else
				self:SetAttribute('type', 'spell');
				self:SetAttribute('spell', GetSpellInfo(51005));
				self:SetAttribute('target-item', GetItemInfo(item));
			end
		else
			print("You don't have enough herbs to mill!");
		end
	else
		print("You don't have any herbs to mill!");
	end
end

function profbars_preclick_insc1(self, button, down)
	if GetItemCount(22790) or GetItemCount(22786) or GetItemCount(22785) or GetItemCount(22793) or GetItemCount(22791) or GetItemCount(22792) or GetItemCount(22787) or GetItemCount(22789) then
		local item
		if GetItemCount(22790)>=5 then
			item=22790;
		elseif GetItemCount(22786)>=5 then
			item=22786;
		elseif GetItemCount(22785)>=5 then
			item=22785;
		elseif GetItemCount(22793)>=5 then
			item=22793;
		elseif GetItemCount(22791)>=5 then
			item=22791;
		elseif GetItemCount(22792)>=5 then
			item=22792;
		elseif GetItemCount(22787)>=5 then
			item=22787;
		elseif GetItemCount(22789)>=5 then
			item=22789;
		end
		if item then
			local a, b = SearchPlayerBags(item, 1);
			local _, c = GetContainerItemInfo(a, b);
			local d, e, f
			if c < 5 then
				d, e = SearchPlayerBags(item, 2);
				_, f = GetContainerItemInfo(d, e);
				if (c+f) < 5 then
					SplitContainerItem(d, e, f);
				else
					SplitContainerItem(d, e, (5-c));
				end
				PickupContainerItem(a, b);
				print("Re-stacked items to allow milling, click again to start.");
			else
				self:SetAttribute('type', 'spell');
				self:SetAttribute('spell', GetSpellInfo(51005));
				self:SetAttribute('target-item', GetItemInfo(item));
			end
		else
			print("You don't have enough herbs to mill!");
		end
	else
		print("You don't have any herbs to mill!");
	end
end

function profbars_preclick_insc4(self, button, down)
	if GetItemCount(13463) or GetItemCount(13464) or GetItemCount(13467) or GetItemCount(13465) or GetItemCount(13466) then
		local item
		if GetItemCount(13463)>=5 then
			item=13463;
		elseif GetItemCount(13464)>=5 then
			item=13464;
		elseif GetItemCount(13467)>=5 then
			item=13467;
		elseif GetItemCount(13465)>=5 then
			item=13465;
		elseif GetItemCount(13466)>=5 then
			item=13466;
		end
		if item then
			local a, b = SearchPlayerBags(item, 1);
			local _, c = GetContainerItemInfo(a, b);
			local d, e, f
			if c < 5 then
				d, e = SearchPlayerBags(item, 2);
				_, f = GetContainerItemInfo(d, e);
				if (c+f) < 5 then
					SplitContainerItem(d, e, f);
				else
					SplitContainerItem(d, e, (5-c));
				end
				PickupContainerItem(a, b);
				print("Re-stacked items to allow milling, click again to start.");
			else
				self:SetAttribute('type', 'spell');
				self:SetAttribute('spell', GetSpellInfo(51005));
				self:SetAttribute('target-item', GetItemInfo(item));
			end
		else
			print("You don't have enough herbs to mill!");
		end
	else
		print("You don't have any herbs to mill!");
	end
end

function profbars_preclick_insc5(self, button, down)
	if GetItemCount(8836) or GetItemCount(8839) or GetItemCount(4625) or GetItemCount(8845) or GetItemCount(8846) or GetItemCount(8831) or GetItemCount(8838) then
		local item
		if GetItemCount(8836)>=5 then
			item=8836;
		elseif GetItemCount(8839)>=5 then
			item=8839;
		elseif GetItemCount(4625)>=5 then
			item=4625;
		elseif GetItemCount(8845)>=5 then
			item=8845;
		elseif GetItemCount(8846)>=5 then
			item=8846;
		elseif GetItemCount(8831)>=5 then
			item=8831;
		elseif GetItemCount(8838)>=5 then
			item=8838;
		end
		if item then
			local a, b = SearchPlayerBags(item, 1);
			local _, c = GetContainerItemInfo(a, b);
			local d, e, f
			if c < 5 then
				d, e = SearchPlayerBags(item, 2);
				_, f = GetContainerItemInfo(d, e);
				if (c+f) < 5 then
					SplitContainerItem(d, e, f);
				else
					SplitContainerItem(d, e, (5-c));
				end
				PickupContainerItem(a, b);
				print("Re-stacked items to allow milling, click again to start.");
			else
				self:SetAttribute('type', 'spell');
				self:SetAttribute('spell', GetSpellInfo(51005));
				self:SetAttribute('target-item', GetItemInfo(item));
			end
		else
			print("You don't have enough herbs to mill!");
		end
	else
		print("You don't have any herbs to mill!");
	end
end

function profbars_preclick_insc6(self, button, down)
	if GetItemCount(3818) or GetItemCount(3821) or GetItemCount(3358) or GetItemCount(3819) then
		local item
		if GetItemCount(3818)>=5 then
			item=3818;
		elseif GetItemCount(3821)>=5 then
			item=3821;
		elseif GetItemCount(3358)>=5 then
			item=3358;
		elseif GetItemCount(3819)>=5 then
			item=3819;
		end
		if item then
			local a, b = SearchPlayerBags(item, 1);
			local _, c = GetContainerItemInfo(a, b);
			local d, e, f
			if c < 5 then
				d, e = SearchPlayerBags(item, 2);
				_, f = GetContainerItemInfo(d, e);
				if (c+f) < 5 then
					SplitContainerItem(d, e, f);
				else
					SplitContainerItem(d, e, (5-c));
				end
				PickupContainerItem(a, b);
				print("Re-stacked items to allow milling, click again to start.");
			else
				self:SetAttribute('type', 'spell');
				self:SetAttribute('spell', GetSpellInfo(51005));
				self:SetAttribute('target-item', GetItemInfo(item));
			end
		else
			print("You don't have enough herbs to mill!");
		end
	else
		print("You don't have any herbs to mill!");
	end
end

function profbars_preclick_insc7(self, button, down)
	if GetItemCount(3369) or GetItemCount(3356) or GetItemCount(3357) or GetItemCount(3355) then
		local item
		if GetItemCount(3369)>=5 then
			item=3369;
		elseif GetItemCount(3356)>=5 then
			item=3356;
		elseif GetItemCount(3357)>=5 then
			item=3357;
		elseif GetItemCount(3355)>=5 then
			item=3355;
		end
		if item then
			local a, b = SearchPlayerBags(item, 1);
			local _, c = GetContainerItemInfo(a, b);
			local d, e, f
			if c < 5 then
				d, e = SearchPlayerBags(item, 2);
				_, f = GetContainerItemInfo(d, e);
				if (c+f) < 5 then
					SplitContainerItem(d, e, f);
				else
					SplitContainerItem(d, e, (5-c));
				end
				PickupContainerItem(a, b);
				print("Re-stacked items to allow milling, click again to start.");
			else
				self:SetAttribute('type', 'spell');
				self:SetAttribute('spell', GetSpellInfo(51005));
				self:SetAttribute('target-item', GetItemInfo(item));
			end
		else
			print("You don't have enough herbs to mill!");
		end
	else
		print("You don't have any herbs to mill!");
	end
end

function profbars_preclick_insc8(self, button, down)
	if GetItemCount(2450) or GetItemCount(2453) or GetItemCount(785) or GetItemCount(3820) or GetItemCount(2452) then
		local item
		if GetItemCount(2450)>=5 then
			item=2450;
		elseif GetItemCount(2453)>=5 then
			item=2453;
		elseif GetItemCount(785)>=5 then
			item=785;
		elseif GetItemCount(3820)>=5 then
			item=3820;
		elseif GetItemCount(2452)>=5 then
			item=2452;
		end
		if item then
			local a, b = SearchPlayerBags(item, 1);
			local _, c = GetContainerItemInfo(a, b);
			local d, e, f
			if c < 5 then
				d, e = SearchPlayerBags(item, 2);
				_, f = GetContainerItemInfo(d, e);
				if (c+f) < 5 then
					SplitContainerItem(d, e, f);
				else
					SplitContainerItem(d, e, (5-c));
				end
				PickupContainerItem(a, b);
				print("Re-stacked items to allow milling, click again to start.");
			else
				self:SetAttribute('type', 'spell');
				self:SetAttribute('spell', GetSpellInfo(51005));
				self:SetAttribute('target-item', GetItemInfo(item));
			end
		else
			print("You don't have enough herbs to mill!");
		end
	else
		print("You don't have any herbs to mill!");
	end
end

function profbars_preclick_insc9(self, button, down)
	if GetItemCount(2449) or GetItemCount(2447) or GetItemCount(765) then
		local item
		if GetItemCount(2449)>=5 then
			item=2449;
		elseif GetItemCount(2447)>=5 then
			item=2447;
		elseif GetItemCount(765)>=5 then
			item=765;
		end
		if item then
			local a, b = SearchPlayerBags(item, 1);
			local _, c = GetContainerItemInfo(a, b);
			local d, e, f
			if c < 5 then
				d, e = SearchPlayerBags(item, 2);
				_, f = GetContainerItemInfo(d, e);
				if (c+f) < 5 then
					SplitContainerItem(d, e, f);
				else
					SplitContainerItem(d, e, (5-c));
				end
				PickupContainerItem(a, b);
				print("Re-stacked items to allow prospecting, click again to start.");
			else
				self:SetAttribute('type', 'spell');
				self:SetAttribute('spell', GetSpellInfo(51005));
				self:SetAttribute('target-item', GetItemInfo(item));
			end
		else
			print("You don't have enough herbs to mill!");
		end
	else
		print("You don't have any herbs to mill!");
	end
end

function profbars_startdragging_jc()
	profbars_jewelcrafting:StartMoving()
end

function profbars_stopdragging_jc()
	profbars_offsets_x["jc"] = profbars_jewelcrafting:GetLeft();
	profbars_offsets_y["jc"] = profbars_jewelcrafting:GetBottom();
	profbars_jewelcrafting:StopMovingOrSizing();
end

function profbars_startdragging_insc()
	profbars_inscription:StartMoving()
end

function profbars_stopdragging_insc()
	profbars_offsets_x["insc"] = profbars_inscription:GetLeft();
	profbars_offsets_y["insc"] = profbars_inscription:GetBottom();
	profbars_inscription:StopMovingOrSizing();
end

--This function is untested
function ProfessionBars:CHAT_MSG_SKILL(msg)
	if PlayerHasSpell(25229) then
		for i=1, GetNumSkillLines() do
			local name,_,_, level = GetSkillLineInfo(i);
			if name==GetSpellInfo(25229) then
				ProfessionBars:jc_showhide(level);
			end
		end
	end
	if PlayerHasSpell(45357) then
		for i=1, GetNumSkillLines() do
			local name,_,_, level = GetSkillLineInfo(i);
			if name==GetSpellInfo(45357) then
				ProfessionBars:insc_showhide(level);
			end
		end
	end
end

function ProfessionBars:TRADE_SKILL_SHOW()
	if profbars_data.mode == 2 then
		local a = GetTradeSkillLine();
		if string.match(a, "%S+") == GetSpellInfo(25229) then
			if IsAddOnLoaded("AdvancedTradeSkillWindow") then
				profbars_jewelcrafting:ClearAllPoints();
				profbars_jewelcrafting:SetPoint("TOP", ATSWFrame, "BOTTOM", 0, 10);
			else
				profbars_jewelcrafting:ClearAllPoints();
				profbars_jewelcrafting:SetPoint("TOPLEFT", TradeSkillFrame, "BOTTOMLEFT", 20, 70);
			end
			if PlayerHasSpell(45357) then
				profbars_inscription:Hide()
			end
			profbars_jewelcrafting:Show();
		elseif string.match(a, "%S+") == GetSpellInfo(45357) then
			if IsAddOnLoaded("AdvancedTradeSkillWindow") then
				profbars_inscription:ClearAllPoints();
				profbars_inscription:SetPoint("TOP", ATSWFrame, "BOTTOM", 0, 10);
			else
				profbars_inscription:ClearAllPoints();
				profbars_inscription:SetPoint("TOPLEFT", TradeSkillFrame, "BOTTOMLEFT", 20, 70);
			end
			if PlayerHasSpell(25229) then
				profbars_jewelcrafting:Hide();
			end
			profbars_inscription:Show();
		else
			if PlayerHasSpell(25229) then
				profbars_jewelcrafting:Hide();
			end
			if PlayerHasSpell(45357) then
				profbars_inscription:Hide();
			end
		end
	end
end

function ProfessionBars:TRADE_SKILL_CLOSE()
	if profbars_data.mode == 2 then
		if PlayerHasSpell(25229) then
			profbars_jewelcrafting:Hide();
		end
		if PlayerHasSpell(45357) then
			profbars_inscription:Hide();
		end
	end
end

function ProfessionBars:PLAYER_ENTERING_WORLD()
	if PlayerHasSpell(25229) then
		local jc_bar = CreateFrame("Frame", "profbars_jewelcrafting", UIParent);
		jc_bar:SetHeight(35);
		jc_bar:SetMovable(true);	
		--Parent it to UIParent
		if not profbars_offsets_x then
			profbars_offsets_x = {};
			profbars_offsets_y = {};
		end
		if not profbars_offsets_x["jc"] then
			profbars_offsets_x["jc"] = 250;
			profbars_offsets_y["jc"] = 250;
		end
		jc_bar:SetPoint("BOTTOMLEFT", UIParent, profbars_offsets_x["jc"], profbars_offsets_y["jc"]);
		--Set this according to skill later
		jc_bar:SetWidth(332.5);
		--Here starts testing definition of button 1
		local jc_button1 = CreateFrame("Button", "profbars_jcbutton1", profbars_jewelcrafting, "SecureActionButtonTemplate");
		jc_button1:SetHeight(35);
		jc_button1:SetWidth(35);
		jc_button1:SetScript("PreClick", profbars_preclick_jc1);
		jc_button1:RegisterForClicks("AnyUp");
		jc_button1:SetPoint("TOPLEFT", profbars_jewelcrafting, "TOPLEFT", 210, 0);
		jc_button1:SetNormalTexture("Interface\\Icons\\INV_Ore_Adamantium");
		jc_button1:SetHighlightTexture("Interface\\Icons\\INV_Ore_Adamantium", 1.5);
		--Here ends testing definition of button 1
		--button 2 defined
		local jc_button2 = CreateFrame("Button", "profbars_jcbutton2", profbars_jewelcrafting, "SecureActionButtonTemplate");
		jc_button2:SetHeight(35);
		jc_button2:SetWidth(35);
		jc_button2:SetScript("PreClick", profbars_preclick_jc2);
		jc_button2:RegisterForClicks("AnyUp");
		jc_button2:SetPoint("TOPLEFT", profbars_jewelcrafting, "TOPLEFT", 245, 0);
		jc_button2:SetNormalTexture("Interface\\Icons\\INV_Ore_Cobalt");
		jc_button2:SetHighlightTexture("Interface\\Icons\\INV_Ore_Cobalt", 1.5);
		--button 2 done
		local jc_button3 = CreateFrame("Button", "profbars_jcbutton3", profbars_jewelcrafting, "SecureActionButtonTemplate");
		jc_button3:SetHeight(35);
		jc_button3:SetWidth(35);
		jc_button3:SetScript("PreClick", profbars_preclick_jc3);
		jc_button3:RegisterForClicks("AnyUp");
		jc_button3:SetPoint("TOPLEFT", profbars_jewelcrafting, "TOPLEFT", 280, 0);
		jc_button3:SetNormalTexture("Interface\\Icons\\INV_Ore_Saronite_01");
		jc_button3:SetHighlightTexture("Interface\\Icons\\INV_Ore_Saronite_01", 1.5);
		local jc_button4 = CreateFrame("Button", "profbars_jcbutton4", profbars_jewelcrafting, "SecureActionButtonTemplate");
		jc_button4:SetHeight(35);
		jc_button4:SetWidth(35);
		jc_button4:SetScript("PreClick", profbars_preclick_jc4);
		jc_button4:RegisterForClicks("AnyUp");
		jc_button4:SetPoint("TOPLEFT", profbars_jewelcrafting, "TOPLEFT", 175, 0);
		jc_button4:SetNormalTexture("Interface\\Icons\\INV_Ore_FelIron");
		jc_button4:SetHighlightTexture("Interface\\Icons\\INV_Ore_FelIron", 1.5);
		local jc_button5 = CreateFrame("Button", "profbars_jcbutton5", profbars_jewelcrafting, "SecureActionButtonTemplate");
		jc_button5:SetHeight(35);
		jc_button5:SetWidth(35);
		jc_button5:SetScript("PreClick", profbars_preclick_jc5);
		jc_button5:RegisterForClicks("AnyUp");
		jc_button5:SetPoint("TOPLEFT", profbars_jewelcrafting, "TOPLEFT", 140, 0);
		jc_button5:SetNormalTexture("Interface\\Icons\\INV_Ore_Thorium_02");
		jc_button5:SetHighlightTexture("Interface\\Icons\\INV_Ore_Thorium_02", 1.5);
		local jc_button6 = CreateFrame("Button", "profbars_jcbutton6", profbars_jewelcrafting, "SecureActionButtonTemplate");
		jc_button6:SetHeight(35);
		jc_button6:SetWidth(35);
		jc_button6:SetScript("PreClick", profbars_preclick_jc6);
		jc_button6:RegisterForClicks("AnyUp");
		jc_button6:SetPoint("TOPLEFT", profbars_jewelcrafting, "TOPLEFT", 105, 0);
		jc_button6:SetNormalTexture("Interface\\Icons\\INV_Ore_Mithril_02");
		jc_button6:SetHighlightTexture("Interface\\Icons\\INV_Ore_Mithril_02", 1.5);
		local jc_button7 = CreateFrame("Button", "profbars_jcbutton7", profbars_jewelcrafting, "SecureActionButtonTemplate");
		jc_button7:SetHeight(35);
		jc_button7:SetWidth(35);
		jc_button7:SetScript("PreClick", profbars_preclick_jc7);
		jc_button7:RegisterForClicks("AnyUp");
		jc_button7:SetPoint("TOPLEFT", profbars_jewelcrafting, "TOPLEFT", 70, 0);
		jc_button7:SetNormalTexture("Interface\\Icons\\INV_Ore_Iron_01");
		jc_button7:SetHighlightTexture("Interface\\Icons\\INV_Ore_Iron_01", 1.5);
		local jc_button8 = CreateFrame("Button", "profbars_jcbutton8", profbars_jewelcrafting, "SecureActionButtonTemplate");
		jc_button8:SetHeight(35);
		jc_button8:SetWidth(35);
		jc_button8:SetScript("PreClick", profbars_preclick_jc8);
		jc_button8:RegisterForClicks("AnyUp");
		jc_button8:SetPoint("TOPLEFT", profbars_jewelcrafting, "TOPLEFT", 35, 0);
		jc_button8:SetNormalTexture("Interface\\Icons\\INV_Ore_Tin_01");
		jc_button8:SetHighlightTexture("Interface\\Icons\\INV_Ore_Tin_01", 1.5);
		local jc_button9 = CreateFrame("Button", "profbars_jcbutton9", profbars_jewelcrafting, "SecureActionButtonTemplate");
		jc_button9:SetHeight(35);
		jc_button9:SetWidth(35);
		jc_button9:SetScript("PreClick", profbars_preclick_jc9);
		jc_button9:RegisterForClicks("AnyUp");
		jc_button9:SetPoint("TOPLEFT", profbars_jewelcrafting, "TOPLEFT");
		jc_button9:SetNormalTexture("Interface\\Icons\\INV_Ore_Copper_01");
		jc_button9:SetHighlightTexture("Interface\\Icons\\INV_Ore_Copper_01", 1.5);
		local jc_movebutton = CreateFrame("Button", "profbars_jcmove", profbars_jewelcrafting);
		jc_movebutton:SetHeight(17.5);
		jc_movebutton:SetWidth(17.5);
		jc_movebutton:SetScript("OnMouseDown", profbars_startdragging_jc);
		jc_movebutton:SetScript("OnMouseUp", profbars_stopdragging_jc);
		jc_movebutton:SetPoint("TOPRIGHT", profbars_jewelcrafting, "TOPRIGHT");
		jc_movebutton:SetHighlightTexture("Interface\\Icons\\Spell_Arcane_PortalStormWind", 0.8);
		for i=1, GetNumSkillLines() do
			local name,_,_, level = GetSkillLineInfo(i);
			if name==GetSpellInfo(25229) then
				ProfessionBars:jc_showhide(level);
			end
		end
		if profbars_data.mode == 2 then
			if IsAddOnLoaded("AdvancedTradeSkillWindow") then
				jc_bar:ClearAllPoints();
				jc_bar:SetPoint("TOP", ATSWFrame, "BOTTOM", 0, 10);
			else
				jc_bar:ClearAllPoints();
				jc_bar:SetPoint("TOPLEFT", TradeSkillFrame, "BOTTOMLEFT", 20, 70);
			end
			jc_movebutton:Hide();
			jc_bar:Hide();
		end
	end
	if PlayerHasSpell(2259) then
		--Alchemy
	end
	if PlayerHasSpell(2018) then
		--Blacksmithing
	end
	if PlayerHasSpell(7411) then
		--Enchanting
	end
	if PlayerHasSpell(4036) then	
		--Engineering
	end
	if PlayerHasSpell(2366) then
		--Herbalism
	end
	if PlayerHasSpell(45357) then
		local insc_bar = CreateFrame("Frame", "profbars_inscription", UIParent);
		insc_bar:SetHeight(35);
		insc_bar:SetMovable(true);	
		--Parent it to UIParent
		if not profbars_offsets_x then
			profbars_offsets_x = {};
			profbars_offsets_y = {};
		end
		if not profbars_offsets_x["insc"] then
			profbars_offsets_x["insc"] = 250;
			profbars_offsets_y["insc"] = 250;
		end
		insc_bar:SetPoint("BOTTOMLEFT", UIParent, profbars_offsets_x["insc"], profbars_offsets_y["insc"]);
		--Set this according to skill later
		insc_bar:SetWidth(297.5);
		--Here starts testing definition of button 1
		local insc_button1 = CreateFrame("Button", "profbars_inscbutton1", profbars_inscription, "SecureActionButtonTemplate");
		insc_button1:SetHeight(35);
		insc_button1:SetWidth(35);
		insc_button1:SetScript("PreClick", profbars_preclick_insc1);
		insc_button1:RegisterForClicks("AnyUp");
		insc_button1:SetPoint("TOPLEFT", profbars_inscription, "TOPLEFT", 210, 0);
		insc_button1:SetNormalTexture("Interface\\Icons\\inv_inscription_pigment_nether");
		insc_button1:SetHighlightTexture("Interface\\Icons\\inv_inscription_pigment_nether", 1.5);
		--Here ends testing definition of button 1
		--button 2 defined
		local insc_button2 = CreateFrame("Button", "profbars_inscbutton2", profbars_inscription, "SecureActionButtonTemplate");
		insc_button2:SetHeight(35);
		insc_button2:SetWidth(35);
		insc_button2:SetScript("PreClick", profbars_preclick_insc2);
		insc_button2:RegisterForClicks("AnyUp");
		insc_button2:SetPoint("TOPLEFT", profbars_inscription, "TOPLEFT", 245, 0);
		insc_button2:SetNormalTexture("Interface\\Icons\\inv_inscription_pigment_azure");
		insc_button2:SetHighlightTexture("Interface\\Icons\\inv_inscription_pigment_azure", 1.5);
		--button 2 done
		-- local insc_button3 = CreateFrame("Button", "profbars_inscbutton3", profbars_inscription, "SecureActionButtonTemplate");
		-- insc_button3:SetHeight(35);
		-- insc_button3:SetWidth(35);
		-- insc_button3:SetScript("PreClick", profbars_preclick_insc3);
		-- insc_button3:RegisterForClicks("AnyUp");
		-- insc_button3:SetPoint("TOPLEFT", profbars_inscription, "TOPLEFT", 280, 0);
		-- insc_button3:SetNormalTexture("Interface\\Icons\\INV_Ore_Saronite_01");
		-- insc_button3:SetHighlightTexture("Interface\\Icons\\INV_Ore_Saronite_01", 1.5);
		local insc_button4 = CreateFrame("Button", "profbars_inscbutton4", profbars_inscription, "SecureActionButtonTemplate");
		insc_button4:SetHeight(35);
		insc_button4:SetWidth(35);
		insc_button4:SetScript("PreClick", profbars_preclick_insc4);
		insc_button4:RegisterForClicks("AnyUp");
		insc_button4:SetPoint("TOPLEFT", profbars_inscription, "TOPLEFT", 175, 0);
		insc_button4:SetNormalTexture("Interface\\Icons\\inv_inscription_pigment_silvery");
		insc_button4:SetHighlightTexture("Interface\\Icons\\inv_inscription_pigment_silvery", 1.5);
		local insc_button5 = CreateFrame("Button", "profbars_inscbutton5", profbars_inscription, "SecureActionButtonTemplate");
		insc_button5:SetHeight(35);
		insc_button5:SetWidth(35);
		insc_button5:SetScript("PreClick", profbars_preclick_insc5);
		insc_button5:RegisterForClicks("AnyUp");
		insc_button5:SetPoint("TOPLEFT", profbars_inscription, "TOPLEFT", 140, 0);
		insc_button5:SetNormalTexture("Interface\\Icons\\inv_inscription_pigment_violet");
		insc_button5:SetHighlightTexture("Interface\\Icons\\inv_inscription_pigment_violet", 1.5);
		local insc_button6 = CreateFrame("Button", "profbars_inscbutton6", profbars_inscription, "SecureActionButtonTemplate");
		insc_button6:SetHeight(35);
		insc_button6:SetWidth(35);
		insc_button6:SetScript("PreClick", profbars_preclick_insc6);
		insc_button6:RegisterForClicks("AnyUp");
		insc_button6:SetPoint("TOPLEFT", profbars_inscription, "TOPLEFT", 105, 0);
		insc_button6:SetNormalTexture("Interface\\Icons\\inv_inscription_pigment_emerald");
		insc_button6:SetHighlightTexture("Interface\\Icons\\inv_inscription_pigment_emerald", 1.5);
		local insc_button7 = CreateFrame("Button", "profbars_inscbutton7", profbars_inscription, "SecureActionButtonTemplate");
		insc_button7:SetHeight(35);
		insc_button7:SetWidth(35);
		insc_button7:SetScript("PreClick", profbars_preclick_insc7);
		insc_button7:RegisterForClicks("AnyUp");
		insc_button7:SetPoint("TOPLEFT", profbars_inscription, "TOPLEFT", 70, 0);
		insc_button7:SetNormalTexture("Interface\\Icons\\inv_inscription_pigment_golden");
		insc_button7:SetHighlightTexture("Interface\\Icons\\inv_inscription_pigment_golden", 1.5);
		local insc_button8 = CreateFrame("Button", "profbars_inscbutton8", profbars_inscription, "SecureActionButtonTemplate");
		insc_button8:SetHeight(35);
		insc_button8:SetWidth(35);
		insc_button8:SetScript("PreClick", profbars_preclick_insc8);
		insc_button8:RegisterForClicks("AnyUp");
		insc_button8:SetPoint("TOPLEFT", profbars_inscription, "TOPLEFT", 35, 0);
		insc_button8:SetNormalTexture("Interface\\Icons\\inv_inscription_pigment_grey");
		insc_button8:SetHighlightTexture("Interface\\Icons\\inv_inscription_pigment_grey", 1.5);
		local insc_button9 = CreateFrame("Button", "profbars_inscbutton9", profbars_inscription, "SecureActionButtonTemplate");
		insc_button9:SetHeight(35);
		insc_button9:SetWidth(35);
		insc_button9:SetScript("PreClick", profbars_preclick_insc9);
		insc_button9:RegisterForClicks("AnyUp");
		insc_button9:SetPoint("TOPLEFT", profbars_inscription, "TOPLEFT");
		insc_button9:SetNormalTexture("Interface\\Icons\\inv_inscription_pigment_white");
		insc_button9:SetHighlightTexture("Interface\\Icons\\inv_inscription_pigment_white", 1.5);
		local insc_movebutton = CreateFrame("Button", "profbars_inscmove", profbars_inscription);
		insc_movebutton:SetHeight(17.5);
		insc_movebutton:SetWidth(17.5);
		insc_movebutton:SetScript("OnMouseDown", profbars_startdragging_insc);
		insc_movebutton:SetScript("OnMouseUp", profbars_stopdragging_insc);
		insc_movebutton:SetPoint("TOPRIGHT", profbars_inscription, "TOPRIGHT");
		insc_movebutton:SetHighlightTexture("Interface\\Icons\\Spell_Arcane_PortalStormWind", 0.8);
		for i=1, GetNumSkillLines() do
			local name,_,_, level = GetSkillLineInfo(i);
			if name==GetSpellInfo(45357) then
				ProfessionBars:insc_showhide(level);
			end
		end
		if profbars_data.mode == 2 then
			if IsAddOnLoaded("AdvancedTradeSkillWindow") then
				insc_bar:ClearAllPoints();
				insc_bar:SetPoint("TOP", ATSWFrame, "BOTTOM", 0, 10);
			else
				insc_bar:ClearAllPoints();
				insc_bar:SetPoint("TOPLEFT", TradeSkillFrame, "BOTTOMLEFT", 20, 70);
			end
			insc_movebutton:Hide();
			insc_bar:Hide();
		end
	end
	if PlayerHasSpell(2108) then
		--Leatherworking
	end
	if PlayerHasSpell(2575) then
		--Mining
	end
	if PlayerHasSpell(8613) then
		--Skinning
	end
	if PlayerHasSpell(3908) then
		--Tailoring
	end
end
